
--
--		
--
--		$project:	Afterlife Crowd Control | TBC Classic
--		$version:	r19.20502
--		$date:		20/10/2021 R19
--
--		$author:	Michael Boyle (a.k.a. Codermik)
--		$contact:	michael.boyle@softrix.co.uk
--		
--		$twitch:	www.twitch.tv/codermik
--
--
--
--		
--				

-- main 
local Afterlife = CreateFrame("Frame")
Afterlife:RegisterEvent("ADDON_LOADED")
Afterlife:RegisterEvent("CHAT_MSG_ADDON")
Afterlife:RegisterEvent("PLAYER_LOGIN")
Afterlife:RegisterEvent("PLAYER_TARGET_CHANGED")
Afterlife:RegisterEvent("PLAYER_FOCUS_CHANGED")
Afterlife:RegisterEvent("PLAYER_REGEN_DISABLED")
Afterlife:RegisterEvent("PLAYER_REGEN_ENABLED")
Afterlife:RegisterEvent("PLAYER_ENTERING_WORLD")
Afterlife:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
Afterlife:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, arg5) self:OnEvent(event, arg1, arg2, arg3, arg4, arg5) end)
Afterlife:SetScript("OnUpdate", function(self) self:OnUpdate() end)

-- client build info
local buildInfo = select(4, GetBuildInfo())

AFTERLIFE	=	{}
local Version = "r19.20502"
local Date = "20/10/2021"

-- mostly for my use but it will show you the versions
-- of the addon used by yourself and the guild members.
-- set to true if you want this feature.
local AfterlifeVerCheck = false

-- version check
local AfterlifeLocalPrefix = "AfterlifeCC"
local AfterlifeNewSession = true						-- only flag once per session.
local AfterlifeGroupAnnounceVer = true					-- only do it once per session
local AfterlifeRevision = 19

local name = ...

AfterlifeSettings = {

	true,												-- addon active? 
	true,												-- bar anchor visible? 
	true, true,											-- chat / audio announce my crowd controls 
	true, true,											-- chat / audio announce my last 15 seconds
	true, true,											-- chat / audio announce cc breaks
	false, true,										-- chat / audio accounce misses
	false, true,										-- chat / audio announce failures
	true, true,											-- chat / audio announce interrupts
	false,												-- ignore my own cc breaks?
	-- 3d frame
	true,												-- show my controlled target as a 3d model.
	255,355,											-- 3d width / height
	700, 0,												-- 3d position
	-- batman popup
	true,												-- display batman style popup when cc breaks.	21
	-- cc bars
	10, 300, "UP", 15, 250, 4, 20, 1, 9,				-- x, y, dir, height, width, texture, max bars, font (coming soon), font size	22 - 30
	-- diminish returns timer (future)
	10, 390, "UP", 15, 250, 4, 20, 1, 9,				-- x, y, dir, height, width, texture, max bars, font (coming soon), font size	31 - 39
	"Afterlife Crowd Control", "Diminish Returns",		-- group titles		40 / 41

	-- battleground 
	-- (some are not implemented yet)

	false,												-- do announces when im in a battleground?	42
	true,												-- play killing blow sounds		43
	"Male",												-- male or female quake sounds.	44
	true,												-- other funny sounds		45

	-- other
	true,												-- diminish returns 46

}


AfterlifePerCharSettings = {
	-- automatically remove blessing of salvation, announce cooldowns etc.
	false,	-- am i a tank and want the extra tank features?
}

AfterlifePerCharFunnyTankSoundsSettings = {
	false,												
}

-- buff reminders (for future)
AfterlifeMonitoredSpells = {}
-- debuff warnings (for future)
AfterlifeMonitoredDebuffs = {}
-- ignored players (a list of players you want to ignore and not announce for - for future)
AfterlifeIgnoredPlayers = {}

-- spells to remove automatically
AfterlifeSpellRemoval = {
	{ 1038, "Blessing of Salvation" },
	{ 25895, "Greater Blessing of Salvation" },
}

-- tank abilities to announce.
AfterlifeTankAbilities = {
	{ 12976, "Last Stand", ">>>> [Last Stand] has been activated, increasing my health by 30% for 20 seconds!", false, false, nil },	-- 12975 is the actual spell, 12976 is the buff applied.. weird huh?
	{ 871, "Shield Wall", ">>>> [Shield Wall] has been used, lasting for 10 seconds!", false, false, nil },
	{ 1161, "Challenging Shout", ">>>> [Challenging Shout] has been used, I will need some extra healing!", false, false, nil },
	{ 5209, "Challenging Roar", ">>>> [Challenging Roar] has been used, I will need some extra healing!", false, true, nil },
	-- taunts, do i even want to include these?
	{ 355, "Taunt", ">>>> [Taunt] used on ", true, false, "Interface\\AddOns\\Afterlife\\sounds\\other\\taunt.ogg" },
	{ 6795, "Growl", ">>>> [Growl] used on ", true, false, "Interface\\AddOns\\Afterlife\\sounds\\other\\taunt.ogg" },	
}

-- popup
local AieePopup = CreateFrame("Frame", "WarnFrame", UIParent)
AieePopup:SetFrameStrata("BACKGROUND")
AieePopup:SetScript("OnUpdate", function(self, elapsed) self:OnUpdate(self, elapsed) end)
AieePopup:SetWidth(256)
AieePopup:SetHeight(256)
local AieeTexture = AieePopup:CreateTexture(nil, "BACKGROUND")
AieeTexture:SetAllPoints(AieePopup)
AieePopup.texture = AieeTexture
AieePopup:SetPoint("CENTER",0,100)
AieePopup:Hide()

-- 3d Model
local targetFrame = CreateFrame("Frame", nil, UIParent)
targetFrame:SetPoint("TopLeft", UIParent, "BottomLeft", AfterlifeSettings[19], AfterlifeSettings[20])
targetFrame:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
targetFrame:SetMovable(true) 
local targetModel = CreateFrame("PlayerModel", nil, targetFrame)
targetModel:SetScript("OnUpdate", function(self) self:OnUpdate(self) end)
targetModel:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
targetModel:SetAllPoints(targetFrame)
local targetName = targetFrame:CreateFontString(targetFrame, "OVERLAY", "NumberFontNormalLarge")
targetName:SetPoint("Bottom", 0, 5)
local targetTimer = targetFrame:CreateFontString(targetFrame, "OVERLAY", "NumberFontNormalLarge")
targetTimer:SetPoint("Bottom", 0, -15)
local focusFrame = CreateFrame("Frame", nil, UIParent)
focusFrame:SetPoint("TopLeft", UIParent, "BottomLeft", AfterlifeSettings[19], AfterlifeSettings[20])
focusFrame:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
focusFrame:SetMovable(true) 
local focusModel = CreateFrame("PlayerModel", nil, focusFrame)
focusModel:SetScript("OnUpdate", function(self) self:OnUpdate(self) end)
focusModel:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
focusModel:SetAllPoints(focusFrame)
local focusName = focusFrame:CreateFontString(focusFrame, "OVERLAY", "NumberFontNormalLarge")
focusName:SetPoint("Bottom", 0, 5)
local focusTimer = focusFrame:CreateFontString(focusFrame, "OVERLAY", "NumberFontNormalLarge")
focusTimer:SetPoint("Bottom", 0, -15)
targetFrame:Hide()
focusFrame:Hide()


AfterlifeSpells = {
	-- Mage
	{118, "Polymorph Rank 1", 20, nil, true, true, false},	
	{12824, "Polymorph Rank 2", 30, nil, true, true, false},
	{12825, "Polymorph Rank 3", 40, nil, true, true, false},
	{12826, "Polymorph Rank 4", 50, nil, true, true, false},
	{28270, "Polymorph: Cow", 50, nil, true, true, false},
	{28271, "Polymorph: Turtle", 50, nil, true, true, false},
	{28272, "Polymorph: Pig", 50, nil, true, true, false},
	-- Priest
	{9484, "Shackle Undead Rank 1", 30, nil, true, true, false},
	{9485, "Shackle Undead Rank 2", 40, nil, true, true, false},
	{10955, "Shackle Undead Rank 3", 50, nil, true, true, false},
	{605, "Mind Control Rank 1", 15, nil, true, false, false},
	{10911, "Mind Control Rank 2", 15, nil, true, false, false},
	{10912, "Mind Control Rank 3", 15, nil, true, false, false},
	-- Druid
	{339, "Entangling Roots Rank 1", 12, nil, true, true, false},
	{1062, "Entangling Roots Rank 2", 15, nil, true, true, false},
	{5195, "Entangling Roots Rank 3", 18, nil, true, true, false},
	{5196, "Entangling Roots Rank 4", 21, nil, true, true, false},
	{9852, "Entangling Roots Rank 5", 24, nil, true, true, false},
	{9853, "Entangling Roots Rank 6", 27, nil, true, true, false},
	{26989, "Entangling Roots Rank 7", 27, nil, true, true, false},
	{2637, "Hibernate Rank 1", 20, nil, true, true, false},
	{18657, "Hibernate Rank 2", 30, nil, true, true, false},
	{18658, "Hibernate Rank 3", 40, nil, true, true, false},
	-- paladin
	{10326, "Turn Evil", 20, 30, true, true, false},
	{2878, "Turn Undead Rank 1", 10, 30, true, true, false},
	{5627, "Turn Undead Rank 2", 15, 30, true, true, false},	
	{20066, "Repentance", 6, 60, true, true},
	-- warlock
	{5782, "Fear Rank 1", 10, nil, true, true, false},
	{6213, "Fear Rank 2", 15, nil, true, true, false},
	{6215, "Fear Rank 3", 20, nil, true, true, false},	
	{6358, "Seduction", 15, nil, true, true, false},
	{710, "Banish Rank 1", 20, nil, false, false, false},
	{18647, "Banish Rank 2", 30, nil, false, false, false},
	-- hunter
	{3355, "Freezing Trap Effect (Rank 1)", 15, 26, true, true, true},	
	{14308, "Freezing Trap Effect (Rank 2)", 15, 26, true, true, true},
	{14309, "Freezing Trap Effect (Rank 3)", 20, 26, true, true, true},
	-- rogue
	{6770, "Sap Rank 1", 25, nil, true, true, true},
	{2070, "Sap Rank 2", 35, nil, true, true, true},
	{11297, "Sap Rank 3", 45, nil, true, true, true},
	{2094, "Blind", 10, 300, false, true, true},

}

-- trap monitoring (for expires etc)
AfterlifeHunterTraps = {
	{1499, "Freezing Trap Rank 1", 60, 26},
	{14310, "Freezing Trap Rank 2", 60, 26},
	{14311, "Freezing Trap Rank 3", 60, 26},
}
-- monitored traps.
AfterlifeMonitoredTrap = {}

-- textures for the bars
AfterlifeTextures = { 

	"Interface\\Addons\\Afterlife\\graphics\\bantobar.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\charcoal.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\otravi.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\perl.tga",
	"Interface\\Addons\\Afterlife\\graphics\\smooth.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\smudge.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\striped.tga", 

}

AfterlifeDiminishGfx = {
	"Interface\\Addons\\Afterlife\\graphics\\drgreen.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\drred.tga", 
}

AfterlifeGenericIcons = {
	"Interface\\Addons\\Afterlife\\graphics\\timer.tga", 
}

-- chat raid icons
local raidicons = {"{rt1} ","{rt2} ","{rt3} ","{rt4} ","{rt5} ", "{rt6} ","{rt7} ","{rt8} ", ""}

-- Raid icon lookup table used for destFlags
local RaidIconLookup = {
	[COMBATLOG_OBJECT_RAIDTARGET1]=1,
	[COMBATLOG_OBJECT_RAIDTARGET2]=2,
	[COMBATLOG_OBJECT_RAIDTARGET3]=3,
	[COMBATLOG_OBJECT_RAIDTARGET4]=4,
	[COMBATLOG_OBJECT_RAIDTARGET5]=5,
	[COMBATLOG_OBJECT_RAIDTARGET6]=6,
	[COMBATLOG_OBJECT_RAIDTARGET7]=7,
	[COMBATLOG_OBJECT_RAIDTARGET8]=8,
}

-- timer bar raid icon path lookup
local raidiconpaths = {
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_1.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_2.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_3.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_4.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_5.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_6.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_7.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_8.blp",
	"",
}

local addonsounds = {
	-- 15s warning / 10 second countdown.
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\1sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\2sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\3sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\4sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\5sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\6sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\7sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\8sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\9sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\10sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\15sec.ogg",	
	-- other sounds
	"Interface\\AddOns\\Afterlife\\sounds\\other\\interrupt.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\missed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\ccbreak.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\failed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\applied.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\renewed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\alert.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\notify.ogg",
}

local Monitored = {}
local Diminishes = {}
local CastingGuid = nil
local TargetGUID = nil
local FocusGUID = nil
local PlayerGUID = UnitGUID("player")
local PlayerTrapGUID = nil
local PlayersName = UnitName("player")
local LastCCAppliedGuid = 0
local TargetRaidIcon = nil
local TargetRaidIconNum = nil
local FocusRaidIcon = nil
local FocusRaidIconNum = nil
local OutputDestination = nil
local Demo3DFrameShown = false
local playerNotInCombat = true

local lasttime = 0
local lastcount = 0

local OutputMessages = {
	">>>> %s was applied to %s (%ss duration).",
	">>>> %s was renewed on %s (%ss duration).",
	">>>> [%s] has failed on %s (%s)!",
	">>>> Interrupted %s's [%s] using %s!",
	">>>> [%s] on %s breaks in %s seconds!",
	">>>> %s has broken free on %s!",
	">>>> %s on %s was broken by %s's %s!",
}

-- hook up with my modified GTB lib.
AfterlifeLib = LibStub:GetLibrary("Codermik-1.0");
AfterlifePrimaryGroup = AfterlifeLib:RegisterGroup(AfterlifeSettings[40], AfterlifeTextures[AfterlifeSettings[27]])
AfterlifeDiminishGroup = AfterlifeLib:RegisterGroup(AfterlifeSettings[41], AfterlifeTextures[AfterlifeSettings[36]])

--
--	Main OnUpdate Event
--
function Afterlife:OnUpdate()
	Afterlife:RemoveExpired()
	Afterlife:RemoveExpiredTrap()
	Afterlife:AnnounceCountdown()
end

--
--	Set 3D Frame
--
function Afterlife:Set3DTarget()
	targetModel:SetUnit("target")
end

--
--	Set 3D Focus Frame
--
function Afterlife:Set3DFocus()
	focusModel:SetUnit("focus")
end

--
--	Toggle Demo 3D Frame
--
function showDemo3DFrame()
	mobGuid, mobName, _, _, _, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
	if not mobGuid then
		if Demo3DFrameShown then
			-- hide it
			targetFrame:Hide()
			Demo3DFrameShown = false
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Demo 3D target is now hidden.")
		else
			-- show it
			targetModel:SetUnit("player")
			targetName:SetText(PlayersName)
			targetTimer:SetText("Looking Awesome!")
			targetName:SetTextColor(1,1,0,10)
			targetTimer:SetTextColor(0,1,0,10)
			targetFrame:Show()	

			Demo3DFrameShown = true
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Demo 3D target is now shown, use the sliders to position the frame.")
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You currently have a controlled mob, wait until it clears.")
	end
end

--
--	Hide 3D Frame
--
function hideDemo3DFrame()
	-- dont want to be clearning the frame when closing options if theres a cc controlled
	mobGuid, mobName, _, _, _, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
	if not mobGuid then
		hide3DTargetFrame()
	end
end

--
--	Update 3d Position
--
function update3DPosition()
	targetFrame:SetPoint("TopLeft", UIParent, "BottomLeft", AfterlifeSettings[19], AfterlifeSettings[20])	
	focusFrame:SetPoint("TopLeft", UIParent, "BottomLeft", AfterlifeSettings[19], AfterlifeSettings[20])	
end

--
--	Update 3d Size
--
function update3DSize()
	targetFrame:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
	targetModel:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
	focusFrame:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
	focusModel:SetSize(AfterlifeSettings[17], AfterlifeSettings[18])
	focusModel:SetAllPoints(focusFrame)	
end


--
--	Hide 3D Frame
--
function hide3DTargetFrame()
	targetFrame:Hide()
end

--
--	3D Model OnUpdate
--
function targetModel:OnUpdate()
	if AfterlifeSettings[16] then
		-- only really interested in updated my own cc for the 3d model
		local _, mobName, _, _, casterName, _, spellName, _, fireTime, spellDuration, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
		if casterName then
			local timeleft = tonumber(spellDuration)-(GetTime()-tonumber(fireTime))+1;
			timeleft = format("%d",timeleft)
			if(tonumber(timeleft) <= 15.0) then targetTimer:SetTextColor(1,0,0,10) else targetTimer:SetTextColor(0,1,0,10) end
			if(tonumber(timeleft) <= 0) then 
				timeleft = 0; 
			end;
			targetTimer:SetText(timeleft.."s Remaining");
		end
	end

end

--
--	3D Model OnUpdate
--
function focusModel:OnUpdate()
	if AfterlifeSettings[16] then
		-- only really interested in updated my own cc for the 3d model
		local _, mobName, _, _, casterName, _, spellName, _, fireTime, spellDuration, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
		if casterName then
			local timeleft = tonumber(spellDuration)-(GetTime()-tonumber(fireTime))+1;
			timeleft = format("%d",timeleft)
			if(tonumber(timeleft) <= 15.0) then focusTimer:SetTextColor(1,0,0,10) else focusTimer:SetTextColor(0,1,0,10) end
			if(tonumber(timeleft) <= 0) then 
				timeleft = 0; 
			end;
			focusTimer:SetText(timeleft.."s Remaining");
		end
	end

end


--
--	Aieee OnUpdate Event
--
local UpdateInterval = .01; 
local ScaleInterval = .1; 
local AieeScale = .01;
local AieePause = 0;
local GraphicPause = 150; 
local TimeSinceLastUpdate = 0;
local ScaleDirection = "up";
local MovingPopup = false; 
function AieePopup:OnUpdate(self, elapsed)
	if(MovingPopup == false) then
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		while(TimeSinceLastUpdate > UpdateInterval) do 
			if(ScaleDirection == "up") then
				AieeScale = AieeScale + ScaleInterval
				WarnFrame:SetScale(AieeScale)
				if(AieeScale >= 1) then
					ScaleDirection = "pause"
				end
			elseif(ScaleDirection == "down") then
				if(AieeScale <= .2) then
					WarnFrame:Hide()
					return
				else
					AieeScale = AieeScale - ScaleInterval
					WarnFrame:SetScale(AieeScale)
				end;
			elseif(ScaleDirection == "pause") then
				AieePause = AieePause + 1
				if(AieePause > GraphicPause) then
					ScaleDirection = "down"
				end;
			end;
			TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateInterval
		end
	end
end

--
--	Initialise Bar Group
--
function initBarGroup()
	-- crowd controls
	AfterlifePrimaryGroup:RegisterOnMove("AfterlifeCCOnBarMove")
	AfterlifePrimaryGroup:SetInvert(false)
	AfterlifePrimaryGroup:SetScale(1.0)
	AfterlifePrimaryGroup:SetMaxBars(AfterlifeSettings[28])
	AfterlifePrimaryGroup:SetHeight(AfterlifeSettings[25])
	AfterlifePrimaryGroup:SetWidth(AfterlifeSettings[26])
	AfterlifePrimaryGroup:SetDisplayGroup("")
	AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeSettings[2])
	AfterlifePrimaryGroup:SetBarGrowth(AfterlifeSettings[24])
	AfterlifePrimaryGroup:SetGroupFontSize(AfterlifeSettings[30])
	AfterlifePrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeSettings[22], AfterlifeSettings[23])
	-- diminish returns.
	AfterlifeDiminishGroup:RegisterOnMove("AfterlifeDROnBarMove")
	AfterlifeDiminishGroup:SetInvert(false)
	AfterlifeDiminishGroup:SetScale(1.0)
	AfterlifeDiminishGroup:SetMaxBars(AfterlifeSettings[37])
	AfterlifeDiminishGroup:SetHeight(AfterlifeSettings[34])
	AfterlifeDiminishGroup:SetWidth(AfterlifeSettings[35])
	AfterlifeDiminishGroup:SetDisplayGroup("")
	AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeSettings[2])
	AfterlifeDiminishGroup:SetBarGrowth(AfterlifeSettings[33])
	AfterlifeDiminishGroup:SetGroupFontSize(AfterlifeSettings[39])
	AfterlifeDiminishGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeSettings[31], AfterlifeSettings[32])
end
function AfterlifeCCOnBarMove(parent, x, y)
	AfterlifeSettings[22] = x 
	AfterlifeSettings[23] = y 
end
function AfterlifeDROnBarMove(parent, x, y)
	AfterlifeSettings[31] = x 
	AfterlifeSettings[32] = y 
end

--
--	Remove an unwanted buff from the player
--
function Afterlife:CancelMonitoredBuff(buffname, caster, announce)
	local counter = 1
	while UnitBuff("player", counter) do
		local name = UnitBuff("player", counter)
		if string.find(name, buffname) then
			if playerNotInCombat then
				CancelUnitBuff("player", counter)
				if announce then
					if caster then
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffffffff cast by |cffFFFF00"..caster.."|cffffffff was automatically removed.")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffffffff was automatically removed.")
					end
				end
			else
				-- we found a nasty buff and i am in combat, need to warn the player
				PlaySoundFile(addonsounds[18], "Master")
				if announce then
					if caster then
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffff6060 cast by |cffFFFF00"..caster.."|cffff6060 is active and could not be removed automatically due to combat - remove manually to avoid losing threat!")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffff6060 is active and could not be removed automatically due to combat - remove manually to avoid losing threat!")
					end
				end
			end
			return
		end
		counter = counter + 1
	end
end

--
--	Function to check if I am in a guild.
--
function Afterlife:IsPlayerInGuild()
    return IsInGuild() -- and GetGuildInfo("player")
end

---
--- global event processor
---
function Afterlife:OnEvent(event, arg1, arg2, arg3, arg4, arg5)
	
	if event == "ADDON_LOADED" then
		if not arg1 == name then return end
		Afterlife:UnregisterEvent("ADDON_LOADED")
		AfterlifeUpdateSettings()
		initBarGroup()
		-- settings loaded, display a welcome message.
		if AfterlifePerCharSettings[1] then 
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffffffff (Build "..Version.." - "..Date..") Loaded! - type |cffFFFF00/afterlife|cffffffff for options, |cffFFFF00/afterlife tank|cffffffff to activate additional tank helpers (currently |cff00ff00active|cffffffff) - please report any bugs.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffffffff (Build "..Version.." - "..Date..") Loaded! - type |cffFFFF00/afterlife|cffffffff for options, |cffFFFF00/afterlife tank|cffffffff to activate additional tank helpers (currently |cffff0000disabled|cffffffff) - please report any bugs.")
		end
	end

	if event == "PLAYER_LOGIN" then local prefixResult = C_ChatInfo.RegisterAddonMessagePrefix(AfterlifeLocalPrefix) end
	if event == "PLAYER_ENTERING_WORLD" then
		if Afterlife:IsPlayerInGuild() then C_ChatInfo.SendAddonMessage(AfterlifeLocalPrefix, AfterlifeRevision, "GUILD") end
	end

	if event == "CHAT_MSG_ADDON" then
		if arg1 == AfterlifeLocalPrefix then
			-- this is a message from this addon.
			if arg2 then
				arg2 = tonumber(arg2)
				if arg2 > AfterlifeRevision and AfterlifeNewSession then
					-- detected a newer version of the addon, lets let the player know.
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control : |cffffffff There is a new version available, you are using version |cffFFFF00r"..AfterlifeRevision.."|cffffffff and version |cffFFFF00r"..arg2.."|cffffffff is available for download.")
					AfterlifeNewSession = false
				end 
				-- guild version check - for my use testing the addon with the guild testers. --
				if arg5 and AfterlifeVerCheck then 
					PlaySoundFile(addonsounds[19], "Master")
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control : |cffffffffPlayer |cffFFFF00<"..arg5.."|cffffffff> has |cffFFFF00r"..arg2.."|cffffffff installed.") 
				end
			end
		end
	end

	if event == "PLAYER_REGEN_DISABLED" then playerNotInCombat = false end
	if event == "PLAYER_REGEN_ENABLED" then 
		playerNotInCombat = true 
		if AfterlifePerCharSettings[1] then Afterlife:RemoveAllMonitoredBuffs() end
	end

	if event == "PLAYER_TARGET_CHANGED" then
		TargetGUID = UnitGUID("target")
		if TargetGUID and not CastingGuid then
			local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
			if not casterName then
				Afterlife:Set3DTarget()
				targetName:SetText(UnitName("target"))
				targetName:SetTextColor(1,1,0,10)
				targetTimer:SetText("Target Selected")
				targetTimer:SetTextColor(0,1,0,10)
			end
		end
	end

	if event == "PLAYER_FOCUS_CHANGED" then
		FocusGUID = UnitGUID("target")
		if FocusGUID then
			Afterlife:Set3DFocus()
			focusName:SetText(UnitName("target"))
			focusName:SetTextColor(1,1,0,10)
			focusTimer:SetText("Target Selected")
			focusTimer:SetTextColor(0,1,0,10)
		end
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" and AfterlifeSettings[1] then		
		local _, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19 = CombatLogGetCurrentEventInfo()
		if arg2 == "SPELL_CAST_START" then
			if Afterlife:InterestedSpell(arg12) then
				if arg4 == PlayerGUID then
					CastingGuid = UnitGUID("target")
					if FocusGUID then
						if FocusGUID == TargetGUID then 
							if AfterlifeSettings[16] then focusFrame:Show() end
						elseif TargetGUID and focusGUID ~= TargetGUID then
							local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
							if not casterName then if AfterlifeSettings[16] then focusFrame:Show() end end
						elseif not TargetGUID then
							if AfterlifeSettings[16] then focusFrame:Show() end
						else
							local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
							if not casterName then
								Afterlife:Set3DTarget()
								targetName:SetText(UnitName("target"))
								targetName:SetTextColor(1,1,0,10)
								targetTimer:SetText("Casting...")
								targetTimer:SetTextColor(0,1,0,10)
								if AfterlifeSettings[16] then targetFrame:Show() end
							end
						end	
					else
						local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
						if not casterName then
							Afterlife:Set3DTarget()
							targetName:SetText(UnitName("target"))
							targetName:SetTextColor(1,1,0,10)
							targetTimer:SetText("Casting...")
							targetTimer:SetTextColor(0,1,0,10)
							if AfterlifeSettings[16] then targetFrame:Show() end
						else
							mobGuid, _, _, _, _, _, spellName, spellBreakable, _, _, _, _, _ = Afterlife:ReadMonitoredMob(arg8)
							if mobGuid then
								Afterlife:Set3DTarget()
								targetName:SetText(UnitName("target"))
								targetName:SetTextColor(1,1,0,10)
								targetTimer:SetText("Casting...")
								targetTimer:SetTextColor(0,1,0,10)
								if AfterlifeSettings[16] then targetFrame:Show() end
							end
						end
					end
				end
			end
		elseif arg2 == "SPELL_CAST_SUCCESS" then
			if Afterlife:InterestedSpell(arg12) then
				_, _, _, _, _, _, isInstant, _ = Afterlife:GetSpellDetails(arg12, arg4, arg8)
				if isInstant then
					if arg4 == PlayerGUID then
						Afterlife:Set3DTarget()
						targetName:SetText(UnitName("target"))
						targetName:SetTextColor(1,1,0,10)
						targetTimer:SetTextColor(0,1,0,10)
						if AfterlifeSettings[16] then targetFrame:Show() end
					end
				else
					if arg4 == PlayerGUID then
						mobGuid, _, _, _, _, _, spellName, spellBreakable, _, _, _, _, _ = Afterlife:ReadMonitoredMob(arg8)
						local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
						if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
						if mobGuid and spellBreakable then
							Afterlife:RemoveMonitoredMob(arg8)
							lasttime = 0
							lastcount = 0
							AfterlifePrimaryGroup:UnregisterBar(arg4)
							spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
							Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
							LastCCAppliedGuid = arg8
						end
					else
						mobGuid, mobName, _, casterGuid, casterName, spellId, spellName, spellBreakable, _, _, _, _, _ = Afterlife:ReadMonitoredMob(arg8)
						if mobGuid and casterGuid == PlayerGUID and spellName == arg13 then
							DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..mobName.."|cffffffff (your original target) had |cffFFFF00"..spellName.."|cffffffff applied by |cffFFFF00"..arg5.."|cffffffff!")
							Afterlife:RemoveMonitoredMob(arg8)
							targetFrame:Hide() 
							focusFrame:Hide()
							local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
							if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
							spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
							Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
							PlaySoundFile(addonsounds[17], "Master") 
						end
					end
				end
			else
				-- extra attention needs to be given on traps, not perfect but i will work out a better solution.
				if arg4 == PlayerGUID then
					-- this was something i did, have i just dropped a trap?
					spellId, spellName, spellDuration, spellCooldown = Afterlife:GetTrapInformaion(arg12)
					if spellName then
						if TargetGUID then
							-- set a expire timer for trap, if we reach it then the 3d frame needs to vanish.
							Afterlife:AddDroppedTrap(arg12, spellDuration, spellCooldown, arg4, GetTime())	
							-- store the target i had when i lay down the trap
							PlayerTrapGUID = TargetGUID
							Afterlife:Set3DTarget()
							targetName:SetText(UnitName("target"))
							targetTimer:SetText("Target Selected")
							targetName:SetTextColor(1,1,0,10)
							targetTimer:SetTextColor(0,1,0,10)
							if AfterlifeSettings[16] then targetFrame:Show() end
						else
							if AfterlifeSettings[16] then
								DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffff6060You must target your intended mob before placing down your trap to correctly set the 3D target - you had no target selected.  Please also note that if a different mob hits your trap then the 3D target frame may show the wrong mob but with correct timers.")
							end
						end
					end
				end
				-- was this a ability I want to shout about?
				if AfterlifePerCharSettings[1] then
					if arg4 == PlayerGUID then
						spellId, spellName, chatMessage, showTarget, eventCheck, soundPath = Afterlife:ReadMonitoredTankAbilities(arg12)
						if spellName and eventCheck == true then
							-- its something I am interested in.
							Afterlife:ChatDestination()	
							if OutputDestination then 
								if showTarget then
									targetsName = UnitName("target")
									if targetsName then
										-- read any raid icon on target.
										targetRaidIcon = GetRaidTargetIndex("target")
										if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
										SendChatMessage(chatMessage..targetRaidIcon..targetsName..".", OutputDestination, NIL)
									else
										SendChatMessage(chatMessage, OutputDestination, NIL) 
									end
								else
									SendChatMessage(chatMessage, OutputDestination, NIL) 
								end
							end
							if AfterlifePerCharFunnyTankSoundsSettings and soundPath then PlaySoundFile(soundPath, "Master") end
						end
					end
				end
			end
		elseif arg2 == "SPELL_AURA_APPLIED" then
			if Afterlife:InterestedSpell(arg12) then
				-- get the raid icon (if any)
				local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
				if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
				if arg4 == PlayerGUID then
					-- this was my cast
					lasttime = 0
					lastcount = 0
					-- remove any generic running timers.
					AfterlifePrimaryGroup:UnregisterBar(arg4)
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
					LastCCAppliedGuid = arg8
				else
					-- this was another player cc
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)					
				end
			else				
				if AfterlifePerCharSettings[1] then
					-- something else was applied to me, was it a buff i want to remove?
					if arg8 == PlayerGUID then
						spellId, spellName = Afterlife:ReadMonitoredBuff(arg12)
						if spellName then
							-- this is a buff I want to remove
							Afterlife:CancelMonitoredBuff(spellName, arg5, true)
						end
					end
					-- was it a tank ability I want to shout about?
					if arg4 == PlayerGUID then
						spellId, spellName, chatMessage, showTarget, eventCheck, soundPath = Afterlife:ReadMonitoredTankAbilities(arg12)
						if spellName and eventCheck ~= true then
							-- its something I am interested in.
							Afterlife:ChatDestination()	
							if OutputDestination then 
								if showTarget then
									targetsName = UnitName("target")
									if targetsName then
										-- read any raid icon on target.
										targetRaidIcon = GetRaidTargetIndex("target")
										if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
										SendChatMessage(chatMessage..targetRaidIcon..targetsName..".", OutputDestination, NIL)
									else
										SendChatMessage(chatMessage, OutputDestination, NIL) 
									end
								else
									SendChatMessage(chatMessage, OutputDestination, NIL) 
								end
							end
							if AfterlifePerCharFunnyTankSoundsSettings and soundPath then PlaySoundFile(soundPath, "Master") end
						end
					end
					-- announce I have a fear ward applied.
					if arg8 == PlayerGUID and arg12 == 6346 then
						Afterlife:ChatDestination()
						msg = string.format(">>> %s applied by %s!", arg13, arg5)
						SendChatMessage(msg, OutputDestination, NIL)
					end
				end
			end
		elseif arg2 == "SPELL_AURA_REFRESH" then
			if Afterlife:InterestedSpell(arg12) then
				-- get raid icon (if any)
				local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
				if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
				if arg4 == PlayerGUID then
					-- this was my cast
					lasttime = 0
					lastcount = 0
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
					LastCCAppliedGuid = arg8
				else
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)					
				end
			end
		elseif arg2 == "SPELL_AURA_REMOVED" or arg2 == "SPELL_AURA_DISPELLED" then
			if Afterlife:InterestedSpell(arg12) then
				Afterlife:DiminishReturnTimer(arg8)
				Afterlife:RemoveBroken(arg8, arg9, arg4, arg5)	
			else
				-- was this something else that dropped which i am interested in.
				if AfterlifePerCharSettings[1] then
					if arg8 == PlayerGUID and arg12 == 6346 then
						Afterlife:ChatDestination()
						msg = string.format(">>> %s has dropped (originally applied by %s)!", arg13, arg5)
						SendChatMessage(msg, OutputDestination, NIL)
					end
				end							
			end		
		elseif arg2 == "SPELL_CAST_FAILED" then
			if Afterlife:InterestedSpell(arg12) then
				if arg4 == PlayerGUID then
					CastingGuid = nil
				end
				local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
				if not casterName then 
					if AfterlifeSettings[16] then 
						targetFrame:Hide() 
						focusFrame:Hide()
					end 
				end
				if arg4 == PlayerGUID and AfterlifeSettings[12] then 
					PlaySoundFile(addonsounds[15], "Master")
				end
			end
		elseif arg2 == "SPELL_MISSED" then
			if Afterlife:InterestedSpell(arg12) and arg4 == PlayerGUID then
				local _, _, _, _, casterName, _, _, _, _, _, _ = Afterlife:ReadMonitoredCaster(PlayerGUID)
				if not casterName then if AfterlifeSettings[16] then targetFrame:Hide() end end
				Afterlife:ChatDestination()	
				msg = string.format(OutputMessages[3], arg13, TargetRaidIcon..arg9, arg15)
				if OutputDestination  and AfterlifeSettings[9] then SendChatMessage(msg, OutputDestination, NIL) 
				else DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..arg13.."|cffffffff has failed on "..arg9.." ("..arg15..").") end
				if AfterlifeSettings[10] then PlaySoundFile(addonsounds[13], "Master") end
			end
		elseif arg2 == "SPELL_AURA_BROKEN_SPELL" or arg2 == "SPELL_AURA_BROKEN" then
			if Afterlife:InterestedSpell(arg12) then
				Afterlife:DiminishReturnTimer(arg8)
				Afterlife:RemovePlayerBroken(arg8, arg9, arg4, arg5, arg16)							
			end		
		elseif arg2 == "PARTY_KILL" or arg2 == "UNIT_DIED" then
			Afterlife:RemoveMonitoredMob(arg8)
			Afterlife:RemoveDiminishReturn(arg8)

		elseif arg2 == "SPELL_INTERRUPT" then 
			if arg4 == PlayerGUID then
				CastingGuid = nil
				if AfterlifeSettings[14] then PlaySoundFile(addonsounds[12], "Master") end
				if AfterlifeSettings[13] then
					Afterlife:ChatDestination()	
					targetRaidIcon = GetRaidTargetIndex("target")
					if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
					msg = string.format(OutputMessages[4], targetRaidIcon..arg9, arg16, arg13)
					if OutputDestination then SendChatMessage(msg, OutputDestination, NIL) end
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..arg9.."'s |cffffffff"..arg16.."|cffFFFF00 was INTERRUPTED!")
				end
			end				
		end		
	end			
end

--
--	Do Aieee popup
--
function Afterlife:DoAieeePopup()
	TimeSinceLastUpdate = 0
	AieeScale = .01
	ScaleDirection = "up"
	AieePause = 0
	AieeTexture:SetTexture("Interface\\AddOns\\Afterlife\\graphics\\aiee.tga")
	WarnFrame:Show()
	WarnFrame:SetScale(AieeScale)
end

--
--	Strip the server name from a player (for cross realm instances and battlegrounds - not needed in classic)
--
function Afterlife:StripServer(name) 
	name = string.match(name, "[^-]*")
	return(name)
end

--
--	Is this target a player?
--
function Afterlife:IsUnitPlayer(guid) 
	local type = strsub(guid, 1, 8)  
	if(type == "Creature") then return false end
	return true;
end

--
--	Determine Chat Destination
--
function Afterlife:ChatDestination()
	local playerInstance, instanceType = IsInInstance()
	if instanceType == "pvp" then 
		if AfterlifeSettings[42] then OutputDestination = "BATTLEGROUND" else OutputDestination = nil end
	else
		numPlayers = GetNumGroupMembers();
		if numPlayers > 1 and numPlayers < 6 then OutputDestination = "PARTY"
		elseif numPlayers >= 6 then	OutputDestination = "RAID"
		else OutputDestination = nil end
	end
end

--
--	Read monitored buffs.
--
function Afterlife:ReadMonitoredTankAbilities(spellId)
	for count,value in ipairs(AfterlifeTankAbilities) do  
		if value[1] == spellId then 
			return value[1], value[2], value[3], value[4], value[5], value[6]
		end
	end
	return false
end

--
--	Read monitored buffs.
--
function Afterlife:ReadMonitoredBuff(spellId)
	for count,value in ipairs(AfterlifeSpellRemoval) do  
		if value[1] == spellId then 
			return value[1], value[2]
		end
	end
	return false
end

--
--	Delete all monitored buffs
--
function Afterlife:RemoveAllMonitoredBuffs()
	for count,value in ipairs(AfterlifeSpellRemoval) do  
		Afterlife:CancelMonitoredBuff(value[2], nil, false)
	end
	return false
end


--
--	Clear Expired Diminish Returns
--
function Afterlife:DeleteExpiredDiminishReturn()
	for count,value in ipairs(Diminishes) do 
		if(value[1]) then
			local fireTime = value[3]
			local timeNow = GetTime()
			local totaDur = timeNow - fireTime
			if(totaDur > 18) then
				tremove(Diminishes, count)
			end
		end
	end
end

--
--	Add/Update Diminish Return
--
function Afterlife:UpdateDiminishReturn(mobGuid, mobName, spellDuration, spellIcon)
	Afterlife:DeleteExpiredDiminishReturn()
	for count,value in ipairs(Diminishes) do 
		if(value[1] == mobGuid) then 
			local lastDur = value[4]
			lastDur = lastDur / 2 
			value[4] = lastDur
			return lastDur
		end
	end
	tinsert(Diminishes, {mobGuid, mobName, GetTime(), spellDuration, spellIcon})
	return spellDuration
end

--
--	Remove Diminish Return
--
function Afterlife:RemoveDiminishReturn(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			AfterlifeDiminishGroup:UnregisterBar(mobGuid);
			tremove(Diminishes, count)
		end
	end
end

--
--	Diminish Return Timer
--
function Afterlife:DiminishReturnTimer(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			value[3] = GetTime()
 			AfterlifeDiminishGroup:SetInvert(false)
			AfterlifeDiminishGroup:RegisterBar(value[1], value[2].." (DR)", 18, 18, value[5], AfterlifeDiminishGfx[2])
		end
	end
end

--
--	Diminish Return Check
--
function Afterlife:DiminishReturnCheck(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			return true
		end
	end
	return false
end

-- 
--	Add Monitored Crowd Control.
--
function Afterlife:AddMonitored(mobGuid, mobName, mobRaidIcon, casterGuid, casterName, spellId, spellName, spellBreakable, fireTime, spellDuration, spellCooldown, spellIcon, iconNumber)
	isRenewal = false	
	Afterlife:RemoveExpired()
	if Afterlife:RemoveMonitored(mobGuid, spellId, casterGuid) then isRenewal = true end
	-- take care if this is a player!
	if Afterlife:IsUnitPlayer(mobGuid) then 
		spellDuration = Afterlife:UpdateDiminishReturn(mobGuid, mobName, spellDuration, spellIcon)
	end
	tinsert(Monitored, {mobGuid, mobName, mobRaidIcon, casterGuid, casterName, spellId, spellName, spellBreakable, fireTime, spellDuration, spellCooldown, mobGuid..casterName})
	AfterlifePrimaryGroup:RegisterBar(mobGuid..casterName, spellName.." ("..casterName..")", spellDuration, spellDuration, spellIcon, raidiconpaths[iconNumber])
	Afterlife:ChatDestination()
	if isRenewal then msg = string.format(OutputMessages[2], spellName, mobRaidIcon..mobName, spellDuration)
	else msg = string.format(OutputMessages[1], spellName, mobRaidIcon..mobName, spellDuration) end
	if casterGuid == PlayerGUID then
		if OutputDestination and AfterlifeSettings[3] then 
			SendChatMessage(msg, OutputDestination, NIL) 
		else
			if isRenewal then DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..spellName.." ("..spellDuration.."s duration)|cffffffff was renewed on "..mobName..".")	
			else DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..spellName.." ("..spellDuration.."s duration)|cffffffff was applied to "..mobName..".") end
		end
		if AfterlifeSettings[4] and isRenewal then 
			PlaySoundFile(addonsounds[17], "Master") 
		elseif AfterlifeSettings[4] then
			PlaySoundFile(addonsounds[16], "Master")
		end 
	end
end

-- 
--	Read Monitored Crowd Control (by mob guid).
--
function Afterlife:ReadMonitoredMob(mobGuid)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			return value[1], value[2], value[3], value[4], value[5], value[6], value[7], value[8], value[9], value[10], value[11]
		end
	end
	return false
end

-- 
--	Read Monitored Crowd Control (by caster guid).
--
function Afterlife:ReadMonitoredCaster(casterGuid)
	for count,value in ipairs(Monitored) do  
		if value[4] == casterGuid then 
			return value[1], value[2], value[3], value[4], value[5], value[6], value[7], value[8], value[9], value[10], value[11]
		end
	end
	return false
end

--
--	Remove entry
--
function Afterlife:RemoveMonitored(mobGuid, spellId, casterGuid)	
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid and value[6] == spellId and value[4] == casterGuid then 
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	Remove expired entry
--
function Afterlife:RemoveExpired()
	for count,value in ipairs(Monitored) do 
		local castTime = value[9]
		local timeNow = GetTime()
		local totaDur = (timeNow - castTime)-1
		if totaDur > value[10] then
			if AfterlifeSettings[16] and value[4] == PlayerGUID then 
				targetFrame:Hide() 
				focusFrame:Hide()
			end
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
		end
	end
end

--
--	Remove dead controlled mob
--
function Afterlife:RemoveMonitoredMob(mobGuid)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	Remove broke crowd control (by player)
--
function Afterlife:RemovePlayerBroken(mobGuid, mobName, casterGuid, casterName, castSpell)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid and value[8] == true then 
			Afterlife:ChatDestination()
			if castSpell then 
				msg = string.format(OutputMessages[7], value[7], value[3]..value[2], casterName, castSpell)
			else
				msg = string.format(OutputMessages[6], value[7], value[3]..value[2])
			end			
			-- I only want to announce if the original cast was mine.
			if value[4] == PlayerGUID then
				CastingGuid = nil
				if OutputDestination and AfterlifeSettings[7] then 
					if casterName == PlayersName then
						-- am i ignoring my own breaks?
						if not AfterlifeSettings[15] then SendChatMessage(msg, OutputDestination, NIL)  end
					else
						-- this wasnt broken by me, just announce.
						SendChatMessage(msg, OutputDestination, NIL) 
					end
				else
					if castSpell then 
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff was broken by |cffFFFF00"..casterName.."'s|cffffffff "..castSpell.."!")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff has broken on |cffFFFF00"..value[2].."|cffffffff!")
					end
				end
				if AfterlifeSettings[16] then 
					targetFrame:Hide() 
					focusFrame:Hide()
				end
			end
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			-- was the caster me breaking my own cc target
			if casterGuid == PlayerGUID and value[4] == PlayerGUID and not AfterlifeSettings[15] then
				-- this was my cast, a cast that i personally broke and i still want to announce.
				if AfterlifeSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeSettings[8] then PlaySoundFile(addonsounds[14], "Master") end
			elseif casterGUID ~= PlayerGUID and value[4] == PlayerGUID then
				-- the caster breaking wasnt me but the original cc target was mine!
				if AfterlifeSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeSettings[8] then PlaySoundFile(addonsounds[14], "Master") end 
			end
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
-- Remove broken crowd control (normal broken)
-- 
function Afterlife:RemoveBroken(mobGuid, mobName, casterGuid, casterName)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			Afterlife:ChatDestination()
			msg = string.format(OutputMessages[6], value[7], value[3]..value[2])
			if value[4] == PlayerGUID then
				CastingGuid = nil
				if OutputDestination and AfterlifeSettings[7] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff has broken on |cffFFFF00"..value[2].."|cffffffff!")
				end
				if AfterlifeSettings[16] then 
					targetFrame:Hide() 
					focusFrame:Hide()
				end
			end
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			if casterGuid == PlayerGUID then
				-- this is my cast and ive not turned off my personal announces.
				if AfterlifeSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeSettings[8] then PlaySoundFile(addonsounds[14], "Master") end
			end
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	quick function to check this is a spell im interested in
--
function Afterlife:InterestedSpell(spellid) 
	for count,value in ipairs(AfterlifeSpells) do 
		if value[1]==spellid then return true end
	end
	return false
end

--
--	get trap information, returns duration and cooldown info
--
function Afterlife:GetTrapInformaion(spellId)
	for count,value in ipairs(AfterlifeHunterTraps) do 
		if value[1]==spellId then 
			return value[1], value[2], value[3], value[4]	-- spellId, spellName, spellDuration, spellCooldown
		end
	end
	return nil
end

--
--	is there a trap already down belonging to me?
--
function Afterlife:CheckTrapDown(spellId, casterGuid)
	for count,value in ipairs(AfterlifeMonitoredTrap) do 
		if value[1]==spellId and value[4] == casterGuid then 
			tremove(AfterlifeMonitoredTrap, count)
		end
	end
end

--
--	Remove expired entry
--
function Afterlife:RemoveExpiredTrap()
	for count,value in ipairs(AfterlifeMonitoredTrap) do 
		local castTime = value[5]
		local timeNow = GetTime()
		local totaDur = (timeNow - castTime) - 1
		if totaDur > value[2] then 
			if AfterlifeSettings[16] and value[4] == PlayerGUID then 
				targetFrame:Hide() 
				focusFrame:Hide()
			end
			tremove(AfterlifeMonitoredTrap, count)
		end
	end
end

--
--	Add Monitored Trap Timer (trap on floor)
--
function Afterlife:AddDroppedTrap(spellId, spellDuration, spellCooldown, casterGuid, fireTime)
	Afterlife:CheckTrapDown(spellId, casterGuid)
	tinsert(AfterlifeMonitoredTrap, {spellId, spellDuration, spellCooldown, casterGuid, fireTime})	
	-- since ive put down a trap, lets give the player a handy trap timer.
	local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellId)
	AfterlifePrimaryGroup:RegisterBar(casterGuid, "Freezing Trap", spellDuration, spellDuration, AfterlifeGenericIcons[1], icon)
end

--
--	return details about an interested cc spell. if the target is a player
--	and the spell duration is 10 or above it will default to the max 10
--
function Afterlife:GetSpellDetails(spellid, casterguid, mobguid)
	for count,value in ipairs(AfterlifeSpells) do 	
		local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellid)
		-- here we need to check if the target was a player to support diminish returns.
		if value[1]==spellid then 
			if Afterlife:IsUnitPlayer(mobguid) and value[3] > 9 then
				-- target is a player, diminish returns come into play here, players
				-- can only be crowd controlled for 10 seconds then halfing each time
				-- to the point of becoming immune from cc for 18 seconds.
				return value[1], value[2], 10, value[4], value[5], value[6], value[7], icon 
			else
				return value[1], value[2], value[3], value[4], value[5], value[6], value[7], icon 
			end
		end
	end
	return nil
end

--
--	Announce last remaining seconds
--
function Afterlife:AnnounceCountdown()
	for count,value in ipairs(Monitored) do 
		if PlayerGUID == value[4] then
			local timeleft = format("%2.1f",tonumber(value[10])-(GetTime()-tonumber(value[9])))
			local counttime = format("%d", timeleft)
			if tonumber(counttime) >= 0 and tonumber(counttime) <= 9 and not(lastcount == counttime) then
				lastcount = counttime
				if AfterlifeSettings[6] then 
					PlaySoundFile(addonsounds[tonumber(counttime)+1], "Master")
				end
			end	
			if tonumber(timeleft) == 15.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 15 seconds!")				
				end
				if AfterlifeSettings[6] then PlaySoundFile(addonsounds[11], "Master") end
			elseif tonumber(timeleft) == 10.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 10 seconds!")				
				end
			elseif tonumber(timeleft) == 5.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 5 seconds!")				
				end
			end					
		end
	end
end

---
--- global slash command processor
---
function ProcessCommandline(args)
	if args == "reset" then
		-- reset bar positions
		AfterlifeSettings[22] = 10 
		AfterlifeSettings[23] = 300
		AfterlifeSettings[2] = true
		AfterlifeSettings[31] = 10 
		AfterlifeSettings[32] = 380
		AfterlifePrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeSettings[22], AfterlifeSettings[23])
		AfterlifeDiminishGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeSettings[31], AfterlifeSettings[32])
		AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeSettings[2])
		if AfterlifeSettings[46] then AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeSettings[2]) end
		options:Show()
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Bar groups have been reset to their default positions.")
	elseif args == "tank" then
		if AfterlifePerCharSettings[1] then 
			AfterlifePerCharSettings[1] = false
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Tank Helper Mode is OFF")
		else
			AfterlifePerCharSettings[1] = true
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Tank Helper Mode is ON - Salvation will be automatically removed out of combat and other additional tank features activated.")
		end
	elseif args == "tanksounds" then
		if AfterlifePerCharFunnyTankSoundsSettings[1] then 
			AfterlifePerCharFunnyTankSoundsSettings[1] = false
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Funny tank sounds are OFF!")
		else
			AfterlifePerCharFunnyTankSoundsSettings[1] = true
			AfterlifePerCharSettings[1] = true
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Tank sounds are ON! - this also requires the tank helper feature to be activated which has been turned on.")
		end
	else
		options:Show()
	end
end


SLASH_AFTERLIFE1				= "/afterlife"
SlashCmdList["AFTERLIFE"] 		= ProcessCommandline



